Unit fta1z_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure fta1z(var ARRAY_ :Array of Extended; N :Integer; IREG :Integer);

implementation

procedure fta1z(var ARRAY_ :Array of Extended; N :Integer;
                IREG :Integer);
var
N2,J,I,M,MMAX,ISTEP :Integer;
TEMPR,TEMPI,WR,WI,WPR,WPI,WTEMP,THETA :Extended;
const
SYS003 :Extended = 6.2831853071795864769252867665590;
label
_10,_20,_30,_40,_50,_60,_70,_80,_85,_90,_100;
begin
N2 := Trunc( 2*N );
J := 1;
I := 1;
while ( I<=N2 ) do
 begin
  if ( J <= I ) 
   then goto _10;
  TEMPR := ARRAY_[J-1];
  TEMPI := ARRAY_[J+0];
  ARRAY_[J-1] := ARRAY_[I-1];
  ARRAY_[J+0] := ARRAY_[I+0];
  ARRAY_[I-1] := TEMPR;
  ARRAY_[I+0] := TEMPI;
_10:
  M := Trunc( N2/2 );
_20:
  if ( (M >= 2) ) and ( (J > M) ) 
   then goto _30;
  goto _40;
_30:
  J := J-M;
  M := Trunc( M/2 );
  goto _20;
_40:
  J := J+M;
_50:
  inc(I,2);
 end;
MMAX := 2;
_60:
if ( N2 <= MMAX ) 
 then goto _85;
ISTEP := Trunc( 2*MMAX );
THETA := SYS003/(IREG*MMAX);
WPR := -2.0e0*IntPower(Sin(0.5e0*THETA),2);
WPI := Sin(THETA);
WR := 1.0e0;
WI := 0.0e0;
M := 1;
while ( M<=MMAX ) do
 begin
  I := M;
  while ( I<=N2 ) do
   begin
    J := I+MMAX;
    TEMPR := WR*ARRAY_[J-1]-WI*ARRAY_[J+0];
    TEMPI := WR*ARRAY_[J+0]+WI*ARRAY_[J-1];
    ARRAY_[J-1] := ARRAY_[I-1]-TEMPR;
    ARRAY_[J+0] := ARRAY_[I+0]-TEMPI;
    ARRAY_[I-1] := ARRAY_[I-1]+TEMPR;
    ARRAY_[I+0] := ARRAY_[I+0]+TEMPI;
_70:
    inc(I,ISTEP);
   end;
  WTEMP := WR;
  WR := WR*WPR-WI*WPI+WR;
  WI := WI*WPR+WTEMP*WPI+WI;
_80:
  inc(M,2);
 end;
MMAX := ISTEP;
goto _60;
_85:
if ( IREG = 1 ) 
 then goto _100;
I := 1;
while ( I<=N2 ) do
 begin
  ARRAY_[I-1] := ARRAY_[I-1]/N;
  ARRAY_[I+0] := ARRAY_[I+0]/N;
_90:
  inc(I,2);
 end;
_100:
end;

end.
